/*
 * Copyright: (c) 2004-2009 Mayo Foundation for Medical Education and 
 * Research (MFMER). All rights reserved. MAYO, MAYO CLINIC, and the
 * triple-shield Mayo logo are trademarks and service marks of MFMER.
 *
 * Except as contained in the copyright notice above, or as used to identify 
 * MFMER as the author of this software, the trade names, trademarks, service
 * marks, or product names of the copyright holder shall not be used in
 * advertising, promotion or otherwise in connection with this software without
 * prior written authorization of the copyright holder.
 * 
 * Licensed under the Eclipse Public License, Version 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at 
 * 
 * 		http://www.eclipse.org/legal/epl-v10.html
 * 
 */
package edu.mayo.informatics.lexgrid.convert.utility;

import org.LexGrid.messaging.LgMessageDirectorIF;
import org.LexGrid.persistence.sql.MessageIF;

/**
 * This class implements the MessageIF as defined in the lexgrid sql plugin - it
 * allows me to catch messages from inside of the sql load process and redirect
 * them to the messaging utilities I use here.
 * 
 * @author <A HREF="mailto:armbrust.daniel@mayo.edu">Dan Armbrust</A>
 * @version subversion $Revision: 7198 $ checked in on $Date: 2008-02-15
 *          18:08:36 +0000 (Fri, 15 Feb 2008) $
 */
public class MessageRedirector implements MessageIF {
    private LgMessageDirectorIF director_;

    public MessageRedirector(LgMessageDirectorIF director) {
        director_ = director;
    }

    public void message(String message, Exception e) {
        director_.warn(message, e);
    }

    public void message(String message) {
        director_.info(message);
    }

}