/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 1.2</a>, using an XML
 * Schema.
 * $Id$
 */

package org.LexGrid.LexBIG.DataModel.cagrid;

/**
 * Class setting policy to resolve a CodedNodeGraph
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings("serial")
public class GraphResolutionPolicy implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Keep the last hop while resolving associations to the
     * resolveAssociationDepth unresolved. This is useful while
     * drawing trees of an ontology and we need a quick way to tell
     * if the tree can be expanded further
     */
    private java.lang.Boolean _keeptLastAssociationUnresolved;

    /**
     * Maximum number of entries to return; a value less than 1
     * Maximum number of entries to return; a value less than 1
     * indicates to return unlimited entries (to the limit
     * specified in the runtime configuration file).
     */
    private java.lang.Integer _maximumToReturn;

    /**
     * Number of hops to resolve associations. 0 means leave all
     * associations unresolved, 1 means immediate neighbors, etc.
     * -1 means follow the entire closure of the graph.
     */
    private java.lang.Integer _resolveAssociationDepth;

    /**
     * True means resolve the target to source associations
     */
    private java.lang.Boolean _resolveBackwards;

    /**
     * Depth in the graph to resolve coded entries. - 1 means don't
     * resolve anything - just return the concept references, 0
     * means resolve just the root nodes, 1 means resolve 1 deep,
     * etc.
     */
    private java.lang.Integer _resolveCodedEntryDepth;

    /**
     * True means resolve from the source to the target direction.
     */
    private java.lang.Boolean _resolveForward;

    /**
     * Field _graphFocus.
     */
    private org.LexGrid.LexBIG.DataModel.Core.ConceptReference _graphFocus;

    /**
     * Field _propertyTypesList.
     */
    private java.util.List<org.LexGrid.LexBIG.DataModel.enums.PropertyType> _propertyTypesList;

    /**
     * Field _filterOptions.
     */
    private org.LexGrid.LexBIG.DataModel.Collections.LocalNameList _filterOptions;

    /**
     * Field _propertyNames.
     */
    private org.LexGrid.LexBIG.DataModel.Collections.LocalNameList _propertyNames;

    /**
     * Field _sortOptions.
     */
    private org.LexGrid.LexBIG.DataModel.Collections.SortOptionList _sortOptions;


      //----------------/
     //- Constructors -/
    //----------------/

    public GraphResolutionPolicy() {
        super();
        this._propertyTypesList = new java.util.ArrayList<org.LexGrid.LexBIG.DataModel.enums.PropertyType>();
    }


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * 
     * 
     * @param vPropertyTypes
     * @throws java.lang.IndexOutOfBoundsException if the index
     * given is outside the bounds of the collection
     */
    public void addPropertyTypes(
            final org.LexGrid.LexBIG.DataModel.enums.PropertyType vPropertyTypes)
    throws java.lang.IndexOutOfBoundsException {
        this._propertyTypesList.add(vPropertyTypes);
    }

    /**
     * 
     * 
     * @param index
     * @param vPropertyTypes
     * @throws java.lang.IndexOutOfBoundsException if the index
     * given is outside the bounds of the collection
     */
    public void addPropertyTypes(
            final int index,
            final org.LexGrid.LexBIG.DataModel.enums.PropertyType vPropertyTypes)
    throws java.lang.IndexOutOfBoundsException {
        this._propertyTypesList.add(index, vPropertyTypes);
    }

    /**
     * Method enumeratePropertyTypes.
     * 
     * @return an Enumeration over all possible elements of this
     * collection
     */
    public java.util.Enumeration<org.LexGrid.LexBIG.DataModel.enums.PropertyType> enumeratePropertyTypes(
    ) {
        return java.util.Collections.enumeration(this._propertyTypesList);
    }

    /**
     * Returns the value of field 'filterOptions'.
     * 
     * @return the value of field 'FilterOptions'.
     */
    public org.LexGrid.LexBIG.DataModel.Collections.LocalNameList getFilterOptions(
    ) {
        return this._filterOptions;
    }

    /**
     * Returns the value of field 'graphFocus'.
     * 
     * @return the value of field 'GraphFocus'.
     */
    public org.LexGrid.LexBIG.DataModel.Core.ConceptReference getGraphFocus(
    ) {
        return this._graphFocus;
    }

    /**
     * Returns the value of field 'keeptLastAssociationUnresolved'.
     * The field 'keeptLastAssociationUnresolved' has the following
     * description: Keep the last hop while resolving associations
     * to the resolveAssociationDepth unresolved. This is useful
     * while drawing trees of an ontology and we need a quick way
     * to tell if the tree can be expanded further
     * 
     * @return the value of field 'KeeptLastAssociationUnresolved'.
     */
    public java.lang.Boolean getKeeptLastAssociationUnresolved(
    ) {
        return this._keeptLastAssociationUnresolved;
    }

    /**
     * Returns the value of field 'maximumToReturn'. The field
     * 'maximumToReturn' has the following description: Maximum
     * number of entries to return; a value less than 1
     * Maximum number of entries to return; a value less than 1
     * indicates to return unlimited entries (to the limit
     * specified in the runtime configuration file).
     * 
     * @return the value of field 'MaximumToReturn'.
     */
    public java.lang.Integer getMaximumToReturn(
    ) {
        return this._maximumToReturn;
    }

    /**
     * Returns the value of field 'propertyNames'.
     * 
     * @return the value of field 'PropertyNames'.
     */
    public org.LexGrid.LexBIG.DataModel.Collections.LocalNameList getPropertyNames(
    ) {
        return this._propertyNames;
    }

    /**
     * Method getPropertyTypes.
     * 
     * @param index
     * @throws java.lang.IndexOutOfBoundsException if the index
     * given is outside the bounds of the collection
     * @return the value of the
     * org.LexGrid.LexBIG.DataModel.enums.PropertyType at the given
     * index
     */
    public org.LexGrid.LexBIG.DataModel.enums.PropertyType getPropertyTypes(
            final int index)
    throws java.lang.IndexOutOfBoundsException {
        // check bounds for index
        if (index < 0 || index >= this._propertyTypesList.size()) {
            throw new IndexOutOfBoundsException("getPropertyTypes: Index value '" + index + "' not in range [0.." + (this._propertyTypesList.size() - 1) + "]");
        }
        
        return (org.LexGrid.LexBIG.DataModel.enums.PropertyType) _propertyTypesList.get(index);
    }

    /**
     * Method getPropertyTypes.Returns the contents of the
     * collection in an Array.  <p>Note:  Just in case the
     * collection contents are changing in another thread, we pass
     * a 0-length Array of the correct type into the API call. 
     * This way we <i>know</i> that the Array returned is of
     * exactly the correct length.
     * 
     * @return this collection as an Array
     */
    public org.LexGrid.LexBIG.DataModel.enums.PropertyType[] getPropertyTypes(
    ) {
        org.LexGrid.LexBIG.DataModel.enums.PropertyType[] array = new org.LexGrid.LexBIG.DataModel.enums.PropertyType[0];
        return (org.LexGrid.LexBIG.DataModel.enums.PropertyType[]) this._propertyTypesList.toArray(array);
    }

    /**
     * Method getPropertyTypesCount.
     * 
     * @return the size of this collection
     */
    public int getPropertyTypesCount(
    ) {
        return this._propertyTypesList.size();
    }

    /**
     * Returns the value of field 'resolveAssociationDepth'. The
     * field 'resolveAssociationDepth' has the following
     * description: Number of hops to resolve associations. 0 means
     * leave all associations unresolved, 1 means immediate
     * neighbors, etc. -1 means follow the entire closure of the
     * graph.
     * 
     * @return the value of field 'ResolveAssociationDepth'.
     */
    public java.lang.Integer getResolveAssociationDepth(
    ) {
        return this._resolveAssociationDepth;
    }

    /**
     * Returns the value of field 'resolveBackwards'. The field
     * 'resolveBackwards' has the following description: True means
     * resolve the target to source associations
     * 
     * @return the value of field 'ResolveBackwards'.
     */
    public java.lang.Boolean getResolveBackwards(
    ) {
        return this._resolveBackwards;
    }

    /**
     * Returns the value of field 'resolveCodedEntryDepth'. The
     * field 'resolveCodedEntryDepth' has the following
     * description: Depth in the graph to resolve coded entries. -
     * 1 means don't resolve anything - just return the concept
     * references, 0 means resolve just the root nodes, 1 means
     * resolve 1 deep, etc.
     * 
     * @return the value of field 'ResolveCodedEntryDepth'.
     */
    public java.lang.Integer getResolveCodedEntryDepth(
    ) {
        return this._resolveCodedEntryDepth;
    }

    /**
     * Returns the value of field 'resolveForward'. The field
     * 'resolveForward' has the following description: True means
     * resolve from the source to the target direction.
     * 
     * @return the value of field 'ResolveForward'.
     */
    public java.lang.Boolean getResolveForward(
    ) {
        return this._resolveForward;
    }

    /**
     * Returns the value of field 'sortOptions'.
     * 
     * @return the value of field 'SortOptions'.
     */
    public org.LexGrid.LexBIG.DataModel.Collections.SortOptionList getSortOptions(
    ) {
        return this._sortOptions;
    }

    /**
     * Returns the value of field 'keeptLastAssociationUnresolved'.
     * The field 'keeptLastAssociationUnresolved' has the following
     * description: Keep the last hop while resolving associations
     * to the resolveAssociationDepth unresolved. This is useful
     * while drawing trees of an ontology and we need a quick way
     * to tell if the tree can be expanded further
     * 
     * @return the value of field 'KeeptLastAssociationUnresolved'.
     */
    public java.lang.Boolean isKeeptLastAssociationUnresolved(
    ) {
        return this._keeptLastAssociationUnresolved;
    }

    /**
     * Returns the value of field 'resolveBackwards'. The field
     * 'resolveBackwards' has the following description: True means
     * resolve the target to source associations
     * 
     * @return the value of field 'ResolveBackwards'.
     */
    public java.lang.Boolean isResolveBackwards(
    ) {
        return this._resolveBackwards;
    }

    /**
     * Returns the value of field 'resolveForward'. The field
     * 'resolveForward' has the following description: True means
     * resolve from the source to the target direction.
     * 
     * @return the value of field 'ResolveForward'.
     */
    public java.lang.Boolean isResolveForward(
    ) {
        return this._resolveForward;
    }

    /**
     * Method iteratePropertyTypes.
     * 
     * @return an Iterator over all possible elements in this
     * collection
     */
    public java.util.Iterator<org.LexGrid.LexBIG.DataModel.enums.PropertyType> iteratePropertyTypes(
    ) {
        return this._propertyTypesList.iterator();
    }

    /**
     */
    public void removeAllPropertyTypes(
    ) {
        this._propertyTypesList.clear();
    }

    /**
     * Method removePropertyTypes.
     * 
     * @param vPropertyTypes
     * @return true if the object was removed from the collection.
     */
    public boolean removePropertyTypes(
            final org.LexGrid.LexBIG.DataModel.enums.PropertyType vPropertyTypes) {
        boolean removed = _propertyTypesList.remove(vPropertyTypes);
        return removed;
    }

    /**
     * Method removePropertyTypesAt.
     * 
     * @param index
     * @return the element removed from the collection
     */
    public org.LexGrid.LexBIG.DataModel.enums.PropertyType removePropertyTypesAt(
            final int index) {
        java.lang.Object obj = this._propertyTypesList.remove(index);
        return (org.LexGrid.LexBIG.DataModel.enums.PropertyType) obj;
    }

    /**
     * Sets the value of field 'filterOptions'.
     * 
     * @param filterOptions the value of field 'filterOptions'.
     */
    public void setFilterOptions(
            final org.LexGrid.LexBIG.DataModel.Collections.LocalNameList filterOptions) {
        this._filterOptions = filterOptions;
    }

    /**
     * Sets the value of field 'graphFocus'.
     * 
     * @param graphFocus the value of field 'graphFocus'.
     */
    public void setGraphFocus(
            final org.LexGrid.LexBIG.DataModel.Core.ConceptReference graphFocus) {
        this._graphFocus = graphFocus;
    }

    /**
     * Sets the value of field 'keeptLastAssociationUnresolved'.
     * The field 'keeptLastAssociationUnresolved' has the following
     * description: Keep the last hop while resolving associations
     * to the resolveAssociationDepth unresolved. This is useful
     * while drawing trees of an ontology and we need a quick way
     * to tell if the tree can be expanded further
     * 
     * @param keeptLastAssociationUnresolved the value of field
     * 'keeptLastAssociationUnresolved'.
     */
    public void setKeeptLastAssociationUnresolved(
            final java.lang.Boolean keeptLastAssociationUnresolved) {
        this._keeptLastAssociationUnresolved = keeptLastAssociationUnresolved;
    }

    /**
     * Sets the value of field 'maximumToReturn'. The field
     * 'maximumToReturn' has the following description: Maximum
     * number of entries to return; a value less than 1
     * Maximum number of entries to return; a value less than 1
     * indicates to return unlimited entries (to the limit
     * specified in the runtime configuration file).
     * 
     * @param maximumToReturn the value of field 'maximumToReturn'.
     */
    public void setMaximumToReturn(
            final java.lang.Integer maximumToReturn) {
        this._maximumToReturn = maximumToReturn;
    }

    /**
     * Sets the value of field 'propertyNames'.
     * 
     * @param propertyNames the value of field 'propertyNames'.
     */
    public void setPropertyNames(
            final org.LexGrid.LexBIG.DataModel.Collections.LocalNameList propertyNames) {
        this._propertyNames = propertyNames;
    }

    /**
     * 
     * 
     * @param index
     * @param vPropertyTypes
     * @throws java.lang.IndexOutOfBoundsException if the index
     * given is outside the bounds of the collection
     */
    public void setPropertyTypes(
            final int index,
            final org.LexGrid.LexBIG.DataModel.enums.PropertyType vPropertyTypes)
    throws java.lang.IndexOutOfBoundsException {
        // check bounds for index
        if (index < 0 || index >= this._propertyTypesList.size()) {
            throw new IndexOutOfBoundsException("setPropertyTypes: Index value '" + index + "' not in range [0.." + (this._propertyTypesList.size() - 1) + "]");
        }
        
        this._propertyTypesList.set(index, vPropertyTypes);
    }

    /**
     * 
     * 
     * @param vPropertyTypesArray
     */
    public void setPropertyTypes(
            final org.LexGrid.LexBIG.DataModel.enums.PropertyType[] vPropertyTypesArray) {
        //-- copy array
        _propertyTypesList.clear();
        
        for (int i = 0; i < vPropertyTypesArray.length; i++) {
                this._propertyTypesList.add(vPropertyTypesArray[i]);
        }
    }

    /**
     * Sets the value of field 'resolveAssociationDepth'. The field
     * 'resolveAssociationDepth' has the following description:
     * Number of hops to resolve associations. 0 means leave all
     * associations unresolved, 1 means immediate neighbors, etc.
     * -1 means follow the entire closure of the graph.
     * 
     * @param resolveAssociationDepth the value of field
     * 'resolveAssociationDepth'.
     */
    public void setResolveAssociationDepth(
            final java.lang.Integer resolveAssociationDepth) {
        this._resolveAssociationDepth = resolveAssociationDepth;
    }

    /**
     * Sets the value of field 'resolveBackwards'. The field
     * 'resolveBackwards' has the following description: True means
     * resolve the target to source associations
     * 
     * @param resolveBackwards the value of field 'resolveBackwards'
     */
    public void setResolveBackwards(
            final java.lang.Boolean resolveBackwards) {
        this._resolveBackwards = resolveBackwards;
    }

    /**
     * Sets the value of field 'resolveCodedEntryDepth'. The field
     * 'resolveCodedEntryDepth' has the following description:
     * Depth in the graph to resolve coded entries. - 1 means don't
     * resolve anything - just return the concept references, 0
     * means resolve just the root nodes, 1 means resolve 1 deep,
     * etc.
     * 
     * @param resolveCodedEntryDepth the value of field
     * 'resolveCodedEntryDepth'.
     */
    public void setResolveCodedEntryDepth(
            final java.lang.Integer resolveCodedEntryDepth) {
        this._resolveCodedEntryDepth = resolveCodedEntryDepth;
    }

    /**
     * Sets the value of field 'resolveForward'. The field
     * 'resolveForward' has the following description: True means
     * resolve from the source to the target direction.
     * 
     * @param resolveForward the value of field 'resolveForward'.
     */
    public void setResolveForward(
            final java.lang.Boolean resolveForward) {
        this._resolveForward = resolveForward;
    }

    /**
     * Sets the value of field 'sortOptions'.
     * 
     * @param sortOptions the value of field 'sortOptions'.
     */
    public void setSortOptions(
            final org.LexGrid.LexBIG.DataModel.Collections.SortOptionList sortOptions) {
        this._sortOptions = sortOptions;
    }

}
