/*
 * Copyright: (c) 2004-2009 Mayo Foundation for Medical Education and 
 * Research (MFMER). All rights reserved. MAYO, MAYO CLINIC, and the
 * triple-shield Mayo logo are trademarks and service marks of MFMER.
 *
 * Except as contained in the copyright notice above, or as used to identify 
 * MFMER as the author of this software, the trade names, trademarks, service
 * marks, or product names of the copyright holder shall not be used in
 * advertising, promotion or otherwise in connection with this software without
 * prior written authorization of the copyright holder.
 * 
 * Licensed under the Eclipse Public License, Version 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at 
 * 
 * 		http://www.eclipse.org/legal/epl-v10.html
 * 
 */
package org.lexgrid.valuedomain.dto;

import org.LexGrid.emf.valueDomains.DefinitionOperator;
import org.LexGrid.valueDomains.EntityReference;

/**
 * A simple wrapper to EntityReference object.
 * @author <A HREF="mailto:dwarkanath.sridhar@mayo.edu">Sridhar Dwarkanath</A>
 */
public class EntityReferenceWrapper extends EntityReference {

	/**
	 * 
	 */
	private static final long serialVersionUID = -178004788864555419L;
	
	private String codingSchemeReference;
	private String valueDomainReference;
	private int ruleOrder;
	private DefinitionOperator definitionOperator;
	
	public String getCodingSchemeReference() {
		return codingSchemeReference;
	}
	public void setCodingSchemeReference(String codingSchemeReference) {
		this.codingSchemeReference = codingSchemeReference;
	}
	public String getValueDomainReference() {
		return valueDomainReference;
	}
	public void setValueDomainReference(String valueDomainReference) {
		this.valueDomainReference = valueDomainReference;
	}
	public int getRuleOrder() {
		return ruleOrder;
	}
	public void setRuleOrder(int ruleOrder) {
		this.ruleOrder = ruleOrder;
	}
	public DefinitionOperator getDefinitionOperator() {
		return definitionOperator;
	}
	public void setDefinitionOperator(DefinitionOperator definitionOperator) {
		this.definitionOperator = definitionOperator;
	}
}